set terminal postscript eps enhanced color solid rounded linewidth 1
set size 0.45,0.45
set style fill solid
set ylabel "Runtime (s)"
set key top left
set log y

set xlabel "Support Threshold"
set xrange [90:40]
set output "fig_8a.eps"
plot 'fig_8a_green.csv' u 1:3 w lines lc rgb "#4daf4a" lw 4 t "New",\
'fig_8a_red.csv' u 1:3 w lines lc rgb "#e41a1c" lw 4 t "Old"

set xlabel "Min Confidence"
set xrange [100:80]
set output "fig_8b.eps"
plot 'fig_8b_green.csv' u 1:2 w lines lc rgb "#4daf4a" lw 4 t "New",\
'fig_8b_red.csv' u ($1*100):2 w lines lc rgb "#e41a1c" lw 4 t "Old"

set xlabel "Max # Nodes in Patterns"
set xrange [3:5]
set output "fig_8c.eps"
plot 'fig_8c_green.csv' u 2:3 w lines lc rgb "#4daf4a" lw 4 t "New",\
'fig_8c_red.csv' u 2:3 w lines lc rgb "#e41a1c" lw 4 t "Old"


