set terminal postscript eps enhanced color solid rounded linewidth 1
set size 0.45,0.45
set style fill solid
set ylabel "Runtime (s)"
set key top left
set yrange [0:]

set xlabel "# Nodes"
set xtics 1000
set output "fig_10a.eps"
plot 'fig_10a_green.csv' u 1:2 w lines lc rgb "#4daf4a" lw 4 t "New",\
'fig_10a_red.csv' u 1:2 w lines lc rgb "#e41a1c" lw 4 t "Old"

set xlabel "# Layers"
set log y
set xtics 1
set output "fig_10b.eps"
plot 'fig_10b_green.csv' u 1:2 w lines lc rgb "#4daf4a" lw 4 t "New",\
'fig_10b_red.csv' u 1:2 w lines lc rgb "#e41a1c" lw 4 t "Old"

set xlabel "Average Degree"
unset log y
set output "fig_10c.eps"
plot 'fig_10c_green.csv' u 1:2 w lines lc rgb "#4daf4a" lw 4 t "New",\
'fig_10c_red.csv' u 1:2 w lines lc rgb "#e41a1c" lw 4 t "Old"

set xlabel "# Node Labels"
set log y
set xrange [5:1]
set output "fig_10d.eps"
plot 'fig_10d_green.csv' u 1:2 w lines lc rgb "#4daf4a" lw 4 t "New",\
'fig_10d_red.csv' u 1:2 w lines lc rgb "#e41a1c" lw 4 t "Old"
